"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (_ref) {
  var t = _ref.types;
  var tmpl = _ref.template;


  var handled = tmpl("{\n window._m && window._m.rH(E,PROBE);\nCATCH\n}\n");

  var unhandled = tmpl("{\n  try {\n      BODY\n  } catch(ex) {\n window._m && window._m.rU(ex, PROBE);\n  }\n}");

  var callback = tmpl("{\n  PROBES\n  BODY\n}");

  var callback_param = tmpl("window._m && window._m.rC(E, PROBE);");

  var hashCode = function hashCode(str) {
    var hash = 0,
        i,
        chr,
        len;
    if (str.length === 0) return hash;
    for (i = 0, len = str.length; i < len; i++) {
      chr = str.charCodeAt(i);
      hash = (hash << 5) - hash + chr;
      hash |= 0;
    }
    return hash;
  };

  var generateProbe = function generateProbe(path, state) {
    var file = state.file.opts.filename;
    file = nodepath.relative(__dirname, file);
    var probeId = (file + ":" + path.node.loc.start.line + "-" + path.node.loc.start.column).replace(/\\/g, '/');
    return hashCode(probeId);
  };

  return {
    visitor: {
      CatchClause: function CatchClause(path, state) {
        try {
          if (state.opts && state.opts.handled && path.node.loc) {
            path.node.body = handled({
              PROBE: t.numericLiteral(generateProbe(path, state)),
              E: path.node.param,
              CATCH: path.node.body.body });
          }
        } catch (err) {
          console.log("processing error", err);
        }
      },
      Function: function Function(path, state) {
        try {
          // Add error callback for parameters
          if (state.opts && state.opts.callback && path.node.loc) {
            var params_tmpl = [];
            for (var i in path.node.params) {
              var param = path.node.params[i];
              params_tmpl.push(callback_param({
                PROBE: t.numericLiteral(generateProbe(path, state)),
                E: param
              }));
            }
            if (params_tmpl.length > 0) {
              path.node.body = callback({
                PROBES: params_tmpl,
                BODY: path.node.body.body
              });
            }
          }

          // Generate a try/catch
          if (state.opts && state.opts.unhandled && path.node.loc) {
            path.node.body = unhandled({
              PROBE: t.numericLiteral(generateProbe(path, state)),
              BODY: path.node.body.body
            });
          }
        } catch (err) {
          console.log("processing error", err);
        }
      }
    }
  };
};

var nodepath = require("path");

module.exports = exports["default"];